
public class MyList {
    
    Object[] arr;
    int head,tail;
    public MyList(int siz){
        arr = new Object[siz+1];
        head = tail = 0;
    }
    public boolean isEmpty(){
        return head == tail;
    }
    // [1,2,3] push 7, will result in [1,2,3,7]
    public void push(Object n){
        arr[head] = n;
        head = (head + 1) % arr.length;
    }

    // [1,2,3] pop will result in 3, leaving [1,2];
    public Object pop(){
        head = (arr.length + head - 1) % arr.length;
        return arr[head];
    }

    // [1,2,3] shift will result in 1, leaving [2,3];
    public Object shift(){
        Object n = arr[tail];
        tail = (tail + 1) % arr.length;
        return n;
    }
    // [1,2,3] unshift 7, will result in [7,1,2,3]
    public void unshift(Object n){
        tail = (arr.length + tail - 1) % arr.length;
        arr[tail] = n;
    }

    // get the ith element in list.
    // [1,2,3], 2nd element is 2.
    public Object get(int i){
        return arr[(tail + i) % arr.length];
    }

    // sets ith element.
    public void set(int i,Object n){
        arr[(tail + i) % arr.length] = n;
    }

    public int size(){
        return ((arr.length + head) - tail) % arr.length;
    }

    // 20091006
    // given a list,
    //  remove n elements starting from s.
    //  replace them with elements in r.
    public void splice(int s,int n,MyList r){
        MyList t = new MyList(arr.length + r.size() + 1);
        for(int i=0;i<s;i++){
            //remove element from this list, and 
            //push it into the temporary list.
            t.push(shift());
        }
        // remove following n elements from 
        // this list.
        for(int i=0;i<n;i++)
            shift();
        // copy r into our temp list
        for(int i=0;i<r.size();i++)
            t.push(r.get(i));
        
        while(size()>0){
            // move remainder of current list into
            // temp list.
            t.push(shift());
        }
        
        // copy t back into "this" list.
        for(int i=0;i<t.size();i++)
            push(t.get(i));
    }

    // 20091006
    public void splice(int s,int n){
        splice(s,n,new MyList(5));
    }

    // 20091006
    public void splice(int s){
        splice(s,size()-s,new MyList(5));
    }

    public void splice(){
        head = tail = 0;
    }

    public String toString(){
        if(isEmpty())
            return "[]";
        String out = "[";
        for(int i=0;i<size()-1;i++){
            out += ""+get(i)+",";
        }
        out += ""+get(size()-1)+"]";
        return out;
    }

    public static void main(String[] args){
        System.out.println("Hello World!");

        MyList l = new MyList(20);
        
        for(int i=0;i<15;i++){
            l.push((int)(Math.random()*100));
        }
        System.out.println("list is: "+l);

        MyList r = new MyList(5);
        r.push(1);
        r.push(2);
        r.push(3);
        r.push(4);
        r.push(5);

        //l.splice(5,3,r);
        //l.splice(5,4);
        //l.splice(5);
        l.splice();

        System.out.println("spliced: "+l);
    }
}

